# pdca0-dev-hub

**pdca0-dev-hub** è un ambiente di sviluppo e gestione per moduli e componenti della piattaforma PDCA0, pensato per facilitare la configurazione, il build, il testing e il rilascio di moduli backend e frontend, con particolare attenzione all'integrazione di moduli XDCE.

## Struttura del progetto

- `cmd/`: Script batch e PowerShell per operazioni di build, configurazione, gestione branch e rilascio.
- `src/darwin/`: Script e strumenti per la gestione di moduli frontend e backend, setup ambienti, configurazione e aggiornamento dipendenze npm.
    - `frontend/`: Script per gestione e aggiornamento pacchetti npm frontend.
    - `backend/`: Script per gestione moduli backend (es. installazione con Maven).
    - `setup-conf/`: Script per configurazione interattiva dei moduli e generazione file di configurazione.
    - `setup-env/`: Script per setup ambiente di sviluppo (es. controlli versioni Node.js, git, ecc).
- `src/general/`: Script generici di utilità, come selezione cartelle progetto.
- `resources/`: File di configurazione JSON condivisi tra gli script.
- `releaser/`: Configurazioni e strumenti per il rilascio e la gestione dei moduli attivi.

## Principali funzionalità

- **Configurazione interattiva**: Script PowerShell con interfaccia grafica per selezionare, configurare e salvare i moduli attivi.
- **Gestione dipendenze**: Script per installazione/aggiornamento dipendenze npm e Maven.
- **Gestione branch**: Script per la creazione e gestione di branch Git nei progetti.
- **Build e rilascio**: Script per build automatizzato, watch dei moduli e rilascio dei pacchetti.

## Requisiti

- **Windows** (testato su Windows 10/11)
- **PowerShell**
- **Node.js v10.24.1**
- **Git**
- (Per backend) **Maven**

## Setup rapido

1. Clona il repository:
   ```sh
   git clone <url-repo>
   ```
2. Configura i moduli tramite gli script in `cmd/` o `src/darwin/setup-conf/`.
3. Per avviare il frontend o il backend, utilizza gli script batch/ps1 dedicati (es. `pdca0-fe.bat`, `pdca0-be.ps1`).
4. Segui le istruzioni a schermo per installare le dipendenze e configurare l'ambiente.

## File di configurazione
- `resources/pdca0-config.json`: Elenco moduli attivi e mapping tra moduli backend/frontend/core/deploy.
- `cmd/pdc-xdce-setup.conf`: Moduli XDCE da monitorare.
- `releaser/pdca0.conf`: Moduli attivi per la fase di rilascio.

