@echo off

set directory=%~1

if not exist "%directory%package.json" (
    (
    echo {
    echo   "name": "package-json-master",
    echo   "version": "0.1.0",
    echo   "scripts": ^{
    echo     "ng": "ng"
    echo   ^},
    echo   "repository": ^{
    echo     "type": "git",
    echo     "url": "example.com"
    echo   ^},
    echo   "author": ^{
    echo     "name": "ARCH",
    echo     "email": "arch@isp.com"
    echo   ^},
    echo   "keywords": ^[
    echo     "angular"
    echo   ^],
    echo   "license": "MIT",
    echo   "bugs": ^{
    echo     "url": "example.com/issues"
    echo   ^},
    echo   "engines": ^{
    echo     "node": ">=6.0.0"
    echo   ^},
    echo   "dependencies": ^{
    echo     "@angular-devkit/architect": "0.11.0",
    echo     "@angular-devkit/build-angular": "0.11.0",
    echo     "@angular-devkit/build-optimizer": "0.11.0",
    echo     "@angular-devkit/core": "7.1.0",
    echo     "@angular-devkit/schematics": "7.1.0",
    echo     "@angular-devkit/schematics-cli": "0.11.0",
    echo     "@angular/cli": "7.1.0",
    echo     "@isp/xdce-build-utils": "1",
    echo     "@isp/xdce-schematics": "1",
    echo     "@schematics/angular": "7.1.0",
    echo     "@schematics/update": "0.11.0",
    echo     "node-sass": "^4.9.3",
    echo     "node-sass-tilde-importer": "1.0.1"
    echo   ^}
    echo ^}
    ) > "%directory%package.json"

    echo Added %directory%package.json
)

:: Create .angular.json file
if not exist "%directory%.angular.json" (
    (
    
    echo ^{
    echo   "$schema": "./node_modules/@angular/cli/lib/config/schema.json",
    echo   "version": 1,
    echo   "newProjectRoot": "projects",
    echo   "projects": ^{
    echo     "showcase-webapp": ^{
    echo       "root": "",
    echo       "sourceRoot": "src",
    echo       "projectType": "application",
    echo       "architect": ^{
    echo         "build": ^{
    echo           "builder": "@angular-devkit/build-angular:browser",
    echo           "options": ^{
    echo             "outputPath": "target/app",
    echo             "index": "src/index.html",
    echo             "main": "src/main.ts",
    echo             "tsConfig": "src/tsconfig.app.json",
    echo             "polyfills": "src/polyfills.ts",
    echo             "extractCss":true,
    echo             "assets": ^[
    echo               "src/assets",
    echo               "src/nginx-cfg",
    echo               "src/nginx-default-cfg",
    echo               "src/favicon.ico",
    echo               "src/login",
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-tutorial/e2e",
    echo                 "output": "/e2e/xdce-module-tutorial"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-tutorial/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-docs/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/showcase-arch-pluggable-impl/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-arch-core-base/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-arch-core/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-tutorial/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/showcase-ui/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/showcase-arch-pluggable-impl/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-arch-core/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-arch-core-base/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-widgetdemo/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-common-docs/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/showcase-ui/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-widget/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo 			         ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-widget/assets",
    echo                 "output": "/assets"
    echo               ^}
    echo             ^],
    echo             "styles": ^[
    echo               ^{
    echo                 "input": "node_modules/@isp/xdce-arch-core/bootstrap/bootstrap.min.css",
    echo                 "bundleName": "bootstrap.css"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/@isp/xdce-arch-core-base/style/xdce-arch-core-base.css",
    echo                 "bundleName": "xdce-arch-core-base.css"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/@isp/xdce-arch-core/style/xdce-arch-core.css",
    echo                 "bundleName": "xdce-arch-core.css"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/@isp/showcase-ui/style/showcase-ui.css",
    echo                 "bundleName": "showcase-ui.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/theme-colors.green.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "theme-colors.green.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/theme-colors.blue.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "theme-colors.blue.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/theme-colors.ipo.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "theme-colors.ipo.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/widget-colors.green.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "widget-colors.green.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/widget-colors.blue.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "widget-colors.blue.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/widget-colors.ipo.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "widget-colors.ipo.css"
    echo               ^},
    echo               "src/styles.scss"
    echo             ^],
    echo             "scripts": ^[
    echo               ^{
    echo                 "input": "node_modules/prismjs/prism.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-typescript.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-sass.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-javascript.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-json.js"
    echo               ^}
    echo             ^]
    echo           ^},
    echo           "configurations": ^{
    echo             "production": ^{
    echo               "optimization": true,
    echo               "outputHashing": "all",
    echo               "sourceMap": false,
    echo               "extractCss": true,
    echo               "namedChunks": false,
    echo               "aot": true,
    echo               "extractLicenses": true,
    echo               "vendorChunk": false,
    echo               "buildOptimizer": true,
    echo               "fileReplacements": ^[
    echo                 ^{
    echo                   "replace": "src/environments/environment.ts",
    echo                   "with": "src/environments/environment.prod.ts"
    echo                 ^}
    echo               ^]
    echo             ^}
    echo           ^}
    echo         ^},
    echo         "serve": ^{
    echo           "builder": "@angular-devkit/build-angular:dev-server",
    echo           "options": ^{
    echo             "browserTarget": "showcase-webapp:build",
    echo             "proxyConfig": "proxy.conf.json"
    echo           ^},
    echo           "configurations": ^{
    echo             "production": ^{
    echo               "extractCss": true,
    echo               "browserTarget": "showcase-webapp:build:production"
    echo             ^}
    echo           ^}
    echo         ^},
    echo         "extract-i18n": ^{
    echo           "builder": "@angular-devkit/build-angular:extract-i18n",
    echo           "options": ^{
    echo             "browserTarget": "showcase-webapp:build"
    echo           ^}
    echo         ^},
    echo         "test": ^{
    echo           "builder": "@angular-devkit/build-angular:karma",
    echo           "options": ^{
    echo             "main": "src/test.ts",
    echo             "karmaConfig": "./karma.conf.js",
    echo             "polyfills": "src/polyfills.ts",
    echo             "tsConfig": "src/tsconfig.spec.json",
    echo             "scripts": ^[
    echo               ^{
    echo                 "input": "node_modules/prismjs/prism.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-typescript.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-sass.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-javascript.js"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/prismjs/components/prism-json.js"
    echo               ^}
    echo             ^],
    echo             "styles": ^[
    echo               ^{
    echo                 "input": "node_modules/@isp/xdce-arch-core/bootstrap/bootstrap.min.css",
    echo                 "bundleName": "bootstrap.css"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/@isp/xdce-arch-core/style/xdce-arch-core.css",
    echo                 "bundleName": "xdce-arch-core.css"
    echo               ^},
    echo               ^{
    echo                 "input": "node_modules/@isp/showcase-ui/style/showcase-ui.css",
    echo                 "bundleName": "showcase-ui.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/theme-colors.green.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "theme-colors.green.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/theme-colors.blue.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "theme-colors.blue.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/theme-colors.ipo.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "theme-colors.ipo.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/widget-colors.green.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "widget-colors.green.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/widget-colors.blue.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "widget-colors.blue.css"
    echo               ^},
    echo               ^{
    echo                 "input": "src/widget-colors.ipo.scss",
    echo                 "lazy": true,
    echo                 "bundleName": "widget-colors.ipo.css"
    echo               ^},
    echo               "src/styles.scss"
    echo             ^],
    echo             "assets": ^[
    echo               "src/assets",
    echo               "src/favicon.ico",
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-tutorial/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-docs/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-bear-docs/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/showcase-arch-pluggable-impl/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-arch-core/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-tutorial/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/showcase-ui/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/showcase-arch-pluggable-impl/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-arch-core/docs",
    echo                 "output": "/docs"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-widgetdemo/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo               ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-module-common-docs/assets",
    echo                 "output": "/assets"
    echo               ^},
    echo 			  ^{
    echo                 "glob": "**/*",
    echo                 "input": "node_modules/@isp/xdce-widget/assets",
    echo                 "output": "/assets"
    echo               ^}
    echo             ^]
    echo           ^}
    echo         ^},
    echo         "lint": ^{
    echo           "builder": "@angular-devkit/build-angular:tslint",
    echo           "options": ^{
    echo             "tsConfig": ^[
    echo               "src/tsconfig.app.json",
    echo               "src/tsconfig.spec.json"
    echo             ^],
    echo             "exclude": ^[
    echo               "**/node_modules/**"
    echo             ^]
    echo           ^}
    echo         ^}
    echo       ^}
    echo     ^},
    echo     "showcase-webapp-e2e": ^{
    echo       "root": "",
    echo       "sourceRoot": "",
    echo       "projectType": "application",
    echo       "architect": ^{
    echo         "e2e": ^{
    echo           "builder": "@angular-devkit/build-angular:protractor",
    echo           "options": ^{
    echo             "protractorConfig": "./protractor.conf.js",
    echo             "devServerTarget": "showcase-webapp:serve"
    echo           ^}
    echo         ^},
    echo         "lint": ^{
    echo           "builder": "@angular-devkit/build-angular:tslint",
    echo           "options": ^{
    echo             "tsConfig": ^[
    echo               "e2e/tsconfig.e2e.json"
    echo             ^],
    echo             "exclude": ^[
    echo               "**/node_modules/**"
    echo             ^]
    echo           ^}
    echo         ^}
    echo       ^}
    echo     ^}
    echo   ^},
    echo   "defaultProject": "showcase-webapp",
    echo   "schematics": ^{
    echo     "@schematics/angular:component": ^{
    echo       "prefix": "app",
    echo       "styleext": "scss"
    echo     ^},
    echo     "@schematics/angular:directive": ^{
    echo       "prefix": "app"
    echo     ^}
    echo   ^}
    echo ^}
    ) > "%directory%.angular.json"

    echo Added %directory%.angular.json
)

endlocal