function Get-TerminalPositions {
    param(
        [int]$count
    )
    $max = 6
    $screen = [System.Windows.Forms.Screen]::PrimaryScreen.Bounds
    $cols = 2
    $rows = [Math]::Ceiling($max / 2)
    $width = [Math]::Floor($screen.Width / $cols)
    $height = [Math]::Floor($screen.Height / [Math]::Min($rows,3))
    $basePositions = @()
    for ($i = 0; $i -lt $max; $i++) {
        $col = $i % 2
        $row = [Math]::Floor($i / 2)
        $x = $col * $width
        $y = $row * $height
        $basePositions += @{ X = $x; Y = $y; Width = $width; Height = $height }
    }
    $positions = @()
    for ($i = 0; $i -lt $count; $i++) {
        $positions += $basePositions[$i % $max]
    }
    return $positions
}
