param(
    [Parameter(Mandatory=$true)]
    [string]$CommandLine,
    [int]$X = 100,
    [int]$Y = 100,
    [int]$Width = 900,
    [int]$Height = 500
)

# Avvia il processo cmd
$proc = Start-Process -FilePath "cmd.exe" -ArgumentList "/k $CommandLine" -PassThru

# Attendi che la finestra sia pronta
Start-Sleep -Milliseconds 700

# Definisci Win32 API per spostare la finestra
Add-Type @"
using System;
using System.Runtime.InteropServices;
public class Win32 {
    [DllImport("user32.dll")]
    public static extern bool MoveWindow(IntPtr hWnd, int X, int Y, int nWidth, int nHeight, bool bRepaint);
}
"@

# Sposta la finestra
$hwnd = $proc.MainWindowHandle
Write-Host "[DEBUG] MoveWindow hwnd=$hwnd X=$X Y=$Y W=$Width H=$Height"
if ($hwnd -ne 0) {
    [Win32]::MoveWindow($hwnd, $X, $Y, $Width, $Height, $true) | Out-Null
}
