# update-path-if-needed.ps1
# Aggiunge riferimenti letterali a variabili d'ambiente nella PATH utente, solo se non già presenti
# Funziona SENZA limiti di lunghezza (al contrario di setx)

$toAdd = @('%JAVA_HOME%\bin', '%M2_HOME%', '%M2%', '%SYMLINK_HOME%')

# Recupera la PATH utente attuale
$userPath = [Environment]::GetEnvironmentVariable('PATH', 'User')
if (-not $userPath) { $userPath = '' }

foreach ($dir in $toAdd) {
    $pattern = [regex]::Escape($dir)
    if ($userPath -notmatch "(^|;)$pattern(;|$)") {
        $userPath += ";$dir"
        Write-Host "Aggiunto $dir alla PATH"
    } else {ç
        Write-Host "$dir già presente nella PATH"
    }
}

[Environment]::SetEnvironmentVariable('PATH', $userPath, 'User')
Write-Host "PATH aggiornata (permanente, solo per l'utente)."
Write-Host "ATTENZIONE: la modifica sarà visibile solo nelle nuove sessioni di prompt/cmd/powershell."
